/*
Copyright (c) 2013-2014 Gustav Hartvigsson

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

/** @file
 * SSTS provides a system for global notifications. Global notifications are
 * like signals, but have global scope, IE: there is only one GlobalNotify
 * object that can exist in the system at any point.
 *
 * It in not possible to directly access the GlobalNotify object, and it's
 * structiral stability can not be guaranteed.
 *
 * SSTS does not initialise the the GlobalNotify object until one of it's
 * function
 */

#ifndef __H_GLOBAL_NOTIFY__
#define __H_GLOBAL_NOTIFY__

#include "defs.h"
#include "Func.h"

BEGIN_DECLS

/**
 * An opaque object.
 * It is not possible to access the data inside this object.
 */
typedef struct _GlobalNotify GlobalNotify;

/**
 * Notify all subscribers of the to the 
 */
void s_global_notify (char * name, spointer * user_data);


void s_global_notiy_add (char * name, );


void s_global_notify_subscribe (char * name, Callback)

END_DECLS
#endif
