/*
*/

#ifndef __H_DEFS__
#define __H_DEFS__

#include <limits.h>

/** @file
 * 
 */

#ifdef __cplusplus
#define BEGIN_DECLS extern "C" {
#else
#define BEGIN_DECLS
#endif /*__cplusplus*/


#ifdef __cplusplus
#define END_DECLS }
#else
#define END_DECLS
#endif /* __cplusplus */

BEGIN_DECLS

#ifndef FALSE
#define FALSE 0
#endif

#ifndef TRUE
#define TRUE !FALSE
#endif

typedef long hash_t;

typedef void* spointer;

typedef enum {
  S_TYPES_NONE = 0,
  S_TYPES_INT,
  S_TYPES_CHAR,
  S_TYPES_SHORT,
  S_TYPES_BOOLEAN,
  S_TYPES_LONG,
  S_TYPES_UINT,
  
  
  S_TYPES_OBJECT = INT_MAX - 1,
  S_TYPES_INVALID = INT_MAX
} S_TYPES;


/* Colour definitions for console prints */
#define RESET   "\033[0m"
#define BLACK   "\033[30m"      /* Black */
#define RED     "\033[31m"      /* Red */
#define GREEN   "\033[32m"      /* Green */
#define YELLOW  "\033[33m"      /* Yellow */
#define BLUE    "\033[34m"      /* Blue */
#define MAGENTA "\033[35m"      /* Magenta */
#define CYAN    "\033[36m"      /* Cyan */
#define WHITE   "\033[37m"      /* White */
#define BOLDBLACK   "\033[1m\033[30m"      /* Bold Black */
#define BOLDRED     "\033[1m\033[31m"      /* Bold Red */
#define BOLDGREEN   "\033[1m\033[32m"      /* Bold Green */
#define BOLDYELLOW  "\033[1m\033[33m"      /* Bold Yellow */
#define BOLDBLUE    "\033[1m\033[34m"      /* Bold Blue */
#define BOLDMAGENTA "\033[1m\033[35m"      /* Bold Magenta */
#define BOLDCYAN    "\033[1m\033[36m"      /* Bold Cyan */
#define BOLDWHITE   "\033[1m\033[37m"      /* Bold White */


END_DECLS

#endif
