/*
Copyright (c) 2013-2014 Gustav Hartvigsson

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

#include "utils.h"
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <time.h>


char * s_string_new (const char * s) {
  char * ret_val = strdup (s);
  return ret_val;
}

char * s_string_new_fmt (const char * format, ...) {
  char * buffer = malloc (strlen (format) + 512);
  char * ret_val = NULL;
  va_list args;
  va_start(args, format);
  vsprintf (buffer, format, args);
  ret_val = (char *) strdup (buffer);
  va_end(args);
  free (buffer);
  return ret_val;
}

char * s_string_new_with_len (const char * s, size_t len) {
  char * ret_val = malloc (len + 1);
  strncpy (ret_val, s, len);
  return ret_val;
}

char * s_current_time (void) {
  char * ret_val = malloc (21);
  time_t t = time (NULL);
  strftime (ret_val, 21, "%F %T", localtime (&t));
  return ret_val;
}
